*** a/src/backend/executor/nodeBitmapHeapscan.c
--- b/src/backend/executor/nodeBitmapHeapscan.c
***************
*** 42,47 ****
--- 42,48 ----
  #include "executor/nodeBitmapHeapscan.h"
  #include "pgstat.h"
  #include "storage/bufmgr.h"
+ #include "storage/predicate.h"
  #include "utils/memutils.h"
  #include "utils/snapmgr.h"
  #include "utils/tqual.h"
***************
*** 364,369 **** bitgetpage(HeapScanDesc scan, TBMIterateResult *tbmres)
--- 365,371 ----
  		Page		dp = (Page) BufferGetPage(buffer);
  		OffsetNumber maxoff = PageGetMaxOffsetNumber(dp);
  		OffsetNumber offnum;
+ 		bool	valid;
  
  		for (offnum = FirstOffsetNumber; offnum <= maxoff; offnum = OffsetNumberNext(offnum))
  		{
***************
*** 375,382 **** bitgetpage(HeapScanDesc scan, TBMIterateResult *tbmres)
  				continue;
  			loctup.t_data = (HeapTupleHeader) PageGetItem((Page) dp, lp);
  			loctup.t_len = ItemIdGetLength(lp);
! 			if (HeapTupleSatisfiesVisibility(&loctup, snapshot, buffer))
  				scan->rs_vistuples[ntup++] = offnum;
  		}
  	}
  
--- 377,392 ----
  				continue;
  			loctup.t_data = (HeapTupleHeader) PageGetItem((Page) dp, lp);
  			loctup.t_len = ItemIdGetLength(lp);
! 			loctup.t_tableOid = scan->rs_rd->rd_id;
! 			ItemPointerSet(&loctup.t_self, page, offnum);
! 			valid = HeapTupleSatisfiesVisibility(&loctup, snapshot, buffer);
! 			if (valid)
! 			{
  				scan->rs_vistuples[ntup++] = offnum;
+ 				PredicateLockTuple(scan->rs_rd, &loctup, snapshot);
+ 			}
+ 			CheckForSerializableConflictOut(valid, scan->rs_rd, &loctup,
+ 											buffer, snapshot);
  		}
  	}
  
